    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------------
    028     * AbstractSeriesDataset.java
    029     * --------------------------
    030     * (C) Copyright 2001-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: AbstractSeriesDataset.java,v 1.4.2.1 2005/10/25 21:32:29 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 17-Nov-2001 : Version 1 (DG);
    040     * 28-Mar-2002 : Implemented SeriesChangeListener interface (DG);
    041     * 04-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    042     * 04-Feb-2003 : Removed redundant methods (DG);
    043     * 27-Mar-2003 : Implemented Serializable (DG);
    044     *
    045     */
    046
    047    package org.jfree.data.general;
    048
    049    import java.io.Serializable;
    050
    051    /**
    052     * An abstract implementation of the {@link SeriesDataset} interface,
    053     * containing a mechanism for registering change listeners.
    054     */
    055    public abstract class AbstractSeriesDataset extends AbstractDataset
    056                                                implements SeriesDataset,
    057                                                           SeriesChangeListener,
    058                                                           Serializable {
    059
    060        /** For serialization. */
    061        private static final long serialVersionUID = -6074996219705033171L;
    062
    063        /**
    064         * Creates a new dataset.
    065         */
    066        protected AbstractSeriesDataset() {
    067            super();
    068        }
    069
    070        /**
    071         * Returns the number of series in the dataset.
    072         *
    073         * @return The series count.
    074         */
    075        public abstract int getSeriesCount();
    076
    077        /**
    078         * Returns the key for a series.
    079         *
    080         * @param series  the series index (zero-based).
    081         *
    082         * @return The series key.
    083         */
    084        public abstract Comparable getSeriesKey(int series);
    085
    086        /**
    087         * Returns the index of the named series, or -1.
    088         *
    089         * @param seriesKey  the series key.
    090         *
    091         * @return The index.
    092         */
    093        public int indexOf(Comparable seriesKey) {
    094            int seriesCount = getSeriesCount();
    095            for (int s = 0; s < seriesCount; s++) {
    096               if (getSeriesKey(s).equals(seriesKey)) {
    097                   return s;
    098               }
    099            }
    100            return -1;
    101        }
    102
    103        /**
    104         * Called when a series belonging to the dataset changes.
    105         *
    106         * @param event  information about the change.
    107         */
    108        public void seriesChanged(SeriesChangeEvent event) {
    109            fireDatasetChanged();
    110        }
    111
    112    }